class Hash

  def string_keys_to_symbol_keys
    returnhash = Hash.new
    self.each_pair do |key, value|
      if value.is_a? Hash then 
        value = value.string_keys_to_symbol_keys
      elsif value.is_a? Array then
        value.map! do |e| 
          if e.is_a? Hash then e.string_keys_to_symbol_keys()
          else e end
        end
      end
      returnhash[key.intern] = value
    end
    return returnhash
  end

  def symbol_keys_to_string_keys
    returnhash = {}
    self.each_pair do |key, value|
      if value.is_a? Hash then
        value = value.symbol_keys_to_string_keys
      elsif value.is_a? Array then
        value.map! do |e| 
          if e.is_a? Hash then e.symbol_keys_to_string_keys
          else e end
        end
      end
      returnhash[key.to_s] = value
    end
    return returnhash
  end

end
