Gem::Specification.new do |s|
  s.name = "extensions"
  s.version = "0.1.0"
  s.date = "2011-05-28"
  s.authors = [ "Matthias Beyer" ]
  s.email = "matthias@ib-fb.de"
  s.summary = "a collection of simple extensions for several classes"
  s.homepage = "https://github.com/matthiasbeyer/clio"
  s.description = "better arrays, better hases, better strings etc."
  s.files = [
    "./lib/extensions.rb",
    "./lib/extensions/array_extensions.rb",
    "./lib/extensions/fixnum_extensions.rb",
    "./lib/extensions/hash_extensions.rb",
    "./lib/extensions/object_extensions.rb",
    "./lib/extensions/string_extensions.rb",
  ]

end
