class Bignum
  def count_up_forever &block
    from = self
    loop do
      block.yield from, self
      from+=1
    end
  end
  
  def count_down_forever &block
    from = self
    loop do
      block.yield from, self
      from-=1
    end
  end
  
  # returns the length of a Fixnum as an String: "?.* E*"
  def length spots = 3
    res = ""

    # length-1 because of shifting the comma on the second position (?.)
    length, value = self.to_s.length-1, self.to_s.each_char.to_a
    
    # building ?. or -?. if self < 0
    if self > 0 then res << value.at(0).to_s <<  "."
    else res << value.at(0).to_s << value.at(1).to_s << "." end
    
    # shifting desired spots into res
    spots.times { |i| res << value.at(i+1).to_s }
    
    return res + " E" + length.to_s
  end
end